#!/bin/bash
#
# Copyright 2011 Adam Bolte <abolte@systemsaviour.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


declare -r tmpFile="$(mktemp /tmp/${0}.XXXXXXXX)" 
declare pkgName
declare -i counter=0
declare -i total

function cleanExit()
{
	echo "Aborting."
	rm -f "${tmpFile}"
	exit 0
}

trap "cleanExit" SIGINT SIGTERM

dpkg --get-selections | grep install | grep -v deinstall | cut -f1 > ${tmpFile}
total=$(cat ${tmpFile} | wc -l)

for pkgName in $(cat ${tmpFile})
do
	((current++))
	echo "Package ${current} of ${total}... ${pkgName}"

	apt-get --reinstall -y --force-yes install ${pkgName}
	apt-get clean
	echo
done
rm -f "${tmpFile}"

echo "Reinstall complete!"
